#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <MAPITags.h>  //contains defintions of properties liested as alternative names.
#include <MAPIdefS.h>  //MAPI data type definitions
#include <malloc.h>
#include <direct.h>

#include "btree.h"          
#include "structures.h"  
#include "crc.h"

#pragma warning (disable:4996)

//my defines
#define FILTERSIZE 134217728 
#define BACKPOINTERSIZE 4
#define UNSIGNEDSIZEINBITS 32
#define BLOCK_SIZE 0x0c

//global counter
unsigned int email_counter = 1; 
unsigned int attachment_counter = 0;
unsigned int pst_counter = 1;

//function prototypes
ULONGLONG get_file_size (HANDLE hd);
DWORD SetFilePointerTo(HANDLE hd,LARGE_INTEGER size, int position);
char is32 (TCHAR * buffer);
header * fillHeader(TCHAR * buffer, char is32or64);
btree64 * build_file_offset_tree(HANDLE hd, TCHAR * buffer, header * h, DWORD number_to_read, ULONGLONG ullDiskSize, int index, char is32or64);
BOOL if_found_at_offset (HANDLE hd, TCHAR * buffer, unsigned __int64 backpointer, long long offset, int position, DWORD number_to_read, int level, int index,char is32or64);
BOOL next_level(HANDLE hd, void * buffer, btree64 * node, DWORD number_to_read,ULONGLONG ullDiskSize, int index, char is32or64);
BOOL validate_sector(TCHAR * buffer,unsigned __int64 backpointer, int offset, int size);
BOOL validate_btree_node(TCHAR * buffer, unsigned __int64 bpointer, int level, int index, char is32or64);
BOOL read_data(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, btree64 * desc, btree64 * offset, header * h, char is32or64);
BOOL read_data2(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, btree64 * node, btree64 * offset, header * h, btree64 * desc, char is32or64);
unsigned __int64 match_i_id (unsigned __int64 DESC_I_ID, unsigned int * s /*out*/, btree64 * offset);
BOOL validate_data2(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, unsigned __int64 offset, int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, 
							btree64 * bbt, unsigned int parent, unsigned __int64 tree_i_id, header * h, btree64 * desc, char is32or64);
TCHAR * read_block_of_data (HANDLE hd, unsigned __int64 offset, DWORD number_to_read, int size, DWORD * num, header * h, char is32or64);
int validate_sector2(TCHAR * buffer, int offset, int size, unsigned int block_size, unsigned __int64 bid_offset, unsigned __int64 desc_i_id, header * h, char is32or64);
item_0002 * populate_02 (HANDLE hd, unsigned int number_to_read, unsigned __int64 tree_offset, int tree_size, header * h, char is32or64);
unsigned int calculate_full_block_size(unsigned int size, char is32or64);
item_0002 * fill_02_data(TCHAR * buffer, unsigned int offset, char is32or64);
BOOL read_bc_block(TCHAR * buffer, __int64 offset, int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, item_0002 * _02, btree64 * bbt, 
					DWORD number_to_read, HANDLE hd, ULONGLONG ullDiskSize, TCHAR * path, header * h, btree64 * desc, char is32or64);
BOOL get_MAPI_element(TCHAR * buffer, HANDLE fl, unsigned short map_offset, unsigned __int64 offset, unsigned char node_type, item_0002 * _02, 
					  btree64 * bbt, DWORD number_to_read, HANDLE hd, unsigned short item_type, unsigned short reference_type, 
					  unsigned int value, /*out*/TCHAR * var_string, header * h, char is32or64, unsigned short * additional_block_header, TCHAR ** additional_buffers,
					  unsigned __int64 * additional_offset);
BOOL get_external_data(unsigned int value, item_0002 * _02, btree64 * bbt, HANDLE fl, DWORD number_to_read, HANDLE hd, unsigned int reference_type, TCHAR * description,
					   header * h, char is32or64);
BOOL write_message_data (TCHAR * buffer, unsigned int start, unsigned int finish, TCHAR * description, unsigned short reference_type,
					unsigned int value, HANDLE fl, unsigned __int64 offset);
unsigned __int64 get_external_offset64(unsigned int value, item_0002 * _02, btree64 * bbt, /*out*/unsigned int * size);
TCHAR * read_external_data (unsigned int size, unsigned __int64 offset, DWORD number_to_read, HANDLE hd,header * h);
BOOL parse_xblock2 (TCHAR * buffer, xblock * xbl, unsigned __int64 offset, DWORD number_to_read, char is32or64);
BOOL parse_xblock (unsigned int value, btree64 * bbt, HANDLE fl, DWORD number_to_read, HANDLE hd,
					   unsigned int reference_type, TCHAR * description, xblock * xbl, TCHAR * external_buffer, unsigned __int64 external_offset,
					   unsigned int size, header * h, char is32or64);
BOOL parse_subnode (item_0002 * _02, btree64 * bbt,/*out params*/unsigned __int64 * recipient_table, unsigned int * rsize, 
					unsigned __int64 * attachment_table, unsigned int * asize, unsigned __int64 * r_subnode_i_id, unsigned __int64 * a_subnode_i_id);
int get_block_type(TCHAR * buffer, unsigned int offset);
BOOL read_7c_block(HANDLE hd, TCHAR * buffer, DWORD number_to_read, ULONGLONG ullDiskSize, int offset, 
				   int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, HANDLE fl, btree64 * bbt, unsigned char node_type, TCHAR * email_name, item_0002 * _02,
				   unsigned __int64 subnode, header * h, btree64 * desc, char is32or64, xblock * xbl);

int main (int argc, char ** argv)
{
	//constants
	const DWORD number_to_read = 0x0200;

	//variables
	HANDLE hd;
	TCHAR * buffer;
	DWORD read = 0;
	BOOL berr;
	ULONGLONG ullDiskSize = 0;
	LARGE_INTEGER next_sector;
	DWORD derr;
	header * h;
	btree64 * head_offset, * head_descriptor; //nbt and bbt trees.
	char is32or64 = 0;

	if (argc < 2)
	{
		printf("Usage: open <filename>.pst.\n");
		exit(-10);
	}
	hd = CreateFile(argv[1],GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hd == INVALID_HANDLE_VALUE)
	{
		printf("Failed to open %s pst file. Error is: %d.\n",argv[1],GetLastError());
		exit(0);
	}
	
	//get size of a file.
	ullDiskSize = get_file_size(hd);

	//set file pointer back to it's begining
	next_sector.QuadPart = 0;
	derr = SetFilePointerTo(hd,next_sector,FILE_BEGIN);
	if (derr == INVALID_SET_FILE_POINTER)
	{
		printf("Error in setting file pointer. Error %d:\n",GetLastError());
		exit(-1);
	}

	buffer =(TCHAR *) malloc(number_to_read * 2);
	if (buffer == NULL)
	{
		printf("Error: Failed in allocating memory for a buffer.\n");
		CloseHandle(hd);
		exit(-2);
	}

	//read header
	berr = ReadFile(hd,buffer,number_to_read * 2,&read,NULL);       //2 sectors needed for UNICODE PST
 	if ( berr == FALSE)
	{
		printf("Error in ReadFile. \nError: %d.\n",GetLastError());
		free(buffer);
		CloseHandle(hd);
		exit(-3);
	}
	
	//determine if this is ANSI or UNICODE PST file.
	is32or64 = is32(buffer);

	//fill up header structure.
	h = fillHeader(buffer,is32or64);
	if(h->size != ullDiskSize)
	{
		printf("Error. Size in a header does not match the size on the disk.\n");
		goto leave;
	}

	//build bbt 
	head_offset = build_file_offset_tree(hd,buffer,h,number_to_read,ullDiskSize,fl_offset,is32or64);
	if(head_offset == NULL)
	{
		printf("Error: Failed to construct btree.\n");
		goto leave;
	}

	//build nbt
	head_descriptor = build_file_offset_tree(hd,buffer,h,number_to_read,ullDiskSize,descriptor,is32or64);
	if(head_descriptor == NULL)
	{
		printf("Error: Failed to construct btree.\n");
		release_bbt(head_offset);
		goto leave;
	}

	//process data
	berr = read_data(hd,number_to_read,ullDiskSize,head_descriptor,head_offset,h,is32or64);
	if(!berr)
	{
		printf("Error: failed to parse pst file.\n");
		release_bbt(head_offset);
		release_bbt(head_descriptor);
		goto leave;
	}


	release_bbt(head_offset);
	release_bbt(head_descriptor);
leave:
	free(h);

	CloseHandle(hd);
	free(buffer);

	return 0;
}

ULONGLONG get_file_size (HANDLE hd)
{
	return (SetFilePointer(hd,0,NULL,FILE_END));
}

DWORD SetFilePointerTo(HANDLE hd, LARGE_INTEGER size, int position)
{
	DWORD derr;

	derr = SetFilePointer(hd,size.LowPart,&size.HighPart,position);
	
	return derr;
}

char is32 (TCHAR * buffer)
{
	int offset = 0x0a;      //data type indicator starts in common header at offset 10.

	if ((buffer[offset] == 0x0e || buffer[offset] == 0x0f) && buffer[offset + 1] == 0x00)
		return 1;
	else if((buffer[offset] == 0x15 || buffer[offset] == 0x17) && buffer[offset + 1] == 0x00)
		return 2;
	else
		return 0;
}

header * fillHeader(TCHAR * buffer, char is32or64)
{
	header * h = (header *) malloc(sizeof(header));
	if (h == NULL)
		return NULL;

	if (is32or64 == 1)
	{
		h->size &= 0;
		memcpy(&h->size,&buffer[0xa8],4);
		h->descriptor_backpointer &= 0;
		memcpy(&h->descriptor_backpointer,&buffer[0xb8],4);
		h->descriptor_offset &= 0;
		memcpy(&h->descriptor_offset,&buffer[0xbc],4);
		h->file_offset_backpointer &= 0;
		memcpy(&h->file_offset_backpointer,&buffer[0xc0],4);
		h->file_offset &= 0;
		memcpy(&h->file_offset,&buffer[0xc4],4);
		h->encryption = buffer[0x1cd];
	}
	else if(is32or64 == 2)
	{
			memcpy(&h->size,&buffer[0xb8],8);
			memcpy(&h->descriptor_backpointer,&buffer[0xd8],8);
			memcpy(&h->descriptor_offset,&buffer[0xe0],8);
			memcpy(&h->file_offset_backpointer,&buffer[0xe8],8);
			memcpy(&h->file_offset,&buffer[0xf0],8);
			h->encryption = buffer[0x0201];
	}

	return h;
}

btree64 * build_file_offset_tree(HANDLE hd, TCHAR * buffer, header * h, DWORD number_to_read, ULONGLONG ullDiskSize, int index, char is32or64)
{
	btree64 * head;
	BOOL berr;

	//look for file offset tree head node.
	if (index == fl_offset)
		berr = if_found_at_offset(hd,buffer,h->file_offset_backpointer,h->file_offset - 0x0400,1,number_to_read,0xffff, index,is32or64);
	else 
		if (index == descriptor)
			berr = if_found_at_offset(hd,buffer,h->descriptor_backpointer, (long long) (h->descriptor_offset),FILE_BEGIN,number_to_read,0xffff, index, is32or64);
	if (!berr)
	{
		return NULL;
	}

	head  = create_head(buffer,3,is32or64);    //btree data contains 3 elements in its key.
	if (head == NULL)
		return NULL;

	//continue looking for all other nodes.
	if ( head->is_leaf)
	{
		berr = next_level(hd,buffer,head,number_to_read,ullDiskSize,index,is32or64);
		if(!berr)
			return NULL;
	}

	return head;
}

BOOL if_found_at_offset (HANDLE hd, TCHAR * buffer, unsigned __int64 backpointer, long long offset, int position, DWORD number_to_read, int level, int index, char is32or64)
{
	BOOL berr;
	DWORD derr;
	LARGE_INTEGER next_sector;
	DWORD read;

	//move file pointer to the specified offset.
	next_sector.QuadPart = offset;
	derr = SetFilePointer(hd,next_sector.LowPart,&next_sector.HighPart,position);
	if (derr == INVALID_SET_FILE_POINTER)
		return FALSE;

	berr = ReadFile(hd,buffer,number_to_read,&read,NULL);
	if (! berr)
		return FALSE;
	//check that backpointers are match.
	berr = validate_sector(buffer,backpointer,0x01f8,(is32or64 == 1 ? 4 : 8));
	if (!berr)
		return FALSE;
	berr = validate_btree_node(buffer,backpointer,level, index, is32or64);
	if(!berr)
		return FALSE;

	return TRUE;
}

BOOL next_level(HANDLE hd, void * buffer, btree64 * node, DWORD number_to_read,ULONGLONG ullDiskSize, int index, char is32or64)
{
	int i = 0, j = 0;	
	BOOL berr;

	//allocate data for next nodes.
	node->next = (btree64 **) HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(btree64*) * node->num_nodes);/*malloc(sizeof(btree*) * node->num_nodes);*/
	if(node->next == NULL)
	{
		printf("Out of memory in next_level.\n");
		return FALSE;
	}

	//find all next level nodes for this node.
	while (i < node->num_nodes )
	{			
		//look for a sector at offset from the begining of a file. If it was not partitioned it should be there, otherwise continue searching
		//forward from this offset position.
		berr = if_found_at_offset(hd,buffer,node->key[i].backpointer, (long long) (node->key[i].offset),FILE_BEGIN,number_to_read, node->is_leaf,index, is32or64);
		if (!berr)
		{
			return FALSE;
		}

		//populate next in btree structure with pointer to the next level nodes.
		node->next[i] = add_node(buffer,3,is32or64);
		if(node->next == NULL)
		{
			printf("Failed to populate next level in next_level function.\n");
			return FALSE;
		}
		i++;
	}

	//if this node is not a leaf node populate next level(s).
	if(node->is_leaf > 1)
	{
		for (i = 0; i < node->num_nodes; i++)
		{
			berr = next_level(hd,buffer,node->next[i],number_to_read,ullDiskSize,index,is32or64);
			if(!berr)
			{
				printf("Failed to populate next level in next_level function.\n");
				return FALSE;
			}
		}
	}

	return TRUE;
}

BOOL validate_sector(TCHAR * buffer,unsigned __int64 backpointer, int offset, int size)
{
	unsigned __int64 temp = 0;

	memcpy(&temp,&buffer[offset],size);
	return (temp == backpointer ? TRUE : FALSE);
}

BOOL validate_btree_node(TCHAR * buffer, unsigned __int64 bpointer, int level, int index, char is32or64)
{
	unsigned char items = 0;              //offset 0x1f0, size 1 byte
	unsigned char max_items = 0;          //offset 0x1f1, size 1 byte = 0x29 
	unsigned int size = 0;                //offset 0x1f2, size 1 byte = 0x0c
	unsigned char node_level = 0;         //offset 0x1f3, size 1 byte
	unsigned short type_indicator = 0;    //offset 0x1f4, size 2 bytes
	unsigned __int64 backpointer = 0;     //offset 0x1f8, size 4 bytes
	int offset = (is32or64 == 1 ? 0x1f0 : 0x01e8);
	DWORD crc = 0;

	items = buffer[offset];
	max_items = buffer[offset + 1];
	size = buffer[offset + 2];
	node_level = buffer[offset + 3];

	if (node_level != 0 || (node_level == 0 && index != descriptor))
	{
		if ( ((max_items != 0x29 && size != 0x0c) && is32or64 == 1) ||     //all items except leafs of a file descriptor
			 ((max_items != 0x14 && size != 0x18) && is32or64 == 2) )
			return FALSE;
	}
	else
	{
		if ( ((max_items != 0x1f && size != 0x10 && index == descriptor && node_level == 0 ) && is32or64 == 1) ||      //just leafs of a file descriptor
		   ( (max_items != 0x0f && size != 0x20 && index == descriptor && node_level == 0 ) && is32or64 == 2))
			return FALSE;
	}

	if ( items > max_items)
		return FALSE;
	
	if (node_level > level)
		return FALSE;

	memcpy(&type_indicator,&buffer[offset + (is32or64 == 1 ? 4 : 8)],2);
	if (type_indicator != 0x8080 && type_indicator !=0x8181)
		return FALSE;

	memcpy(&backpointer,&buffer[offset + (is32or64 == 1 ? 0x08 : 0x10)],4);
	if (backpointer != bpointer)
		return FALSE;

	crc = ComputeCRC(0,buffer,(is32or64 == 1 ? 0x01f4 : 0x01f0));
	if(memcmp(&buffer[(is32or64 == 1 ? 0x01fc : 0x01f4)],&crc,4) != 0)
		return FALSE;
	return TRUE;
}

BOOL read_data(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, btree64 * desc, btree64 * offset, header * h, char is32or64)
{
	BOOL berr;
	int j = 0;
	btree64 * node;

	//find leafs of descriptor btree
	if ( desc->is_leaf != 0)
	{
		while (j < desc->num_nodes)
		{
			node = desc->next[j];
			berr = read_data(hd,number_to_read,ullDiskSize,node,offset,h,is32or64);
			if(!berr)
				return FALSE;

			j++;
		}
	}
	else
	{
		berr = read_data2(hd,number_to_read,ullDiskSize,desc,offset,h,desc,is32or64);
		if (!berr)
			return FALSE;
	}

	return TRUE;
}

BOOL read_data2(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, btree64 * node, btree64 * offset, header * h, btree64 * desc, char is32or64)
{
	int i = 0;
	unsigned __int64 file_offset;
	unsigned int size;
	BOOL berr;

	while (i < node->num_nodes)
	{
		file_offset = match_i_id(node->leaf_d[i].DESC_I_ID,&size,offset);
		//if file offset == 0 then it is template folder for example. but it really presents no interest for our purposes.
		if ( file_offset > 0)
		{
			berr = validate_data2(hd,number_to_read,ullDiskSize,file_offset,size,node->leaf_d[i].DESC_I_ID,
				node->leaf_d[i].D_ID,offset,node->leaf_d[i].PARENT_D_ID,node->leaf_d[i].TREE_I_ID,h,desc,is32or64);
			if (berr == FALSE)
			{
				printf("Failed to recover data block in read_data.\n");
				return FALSE;
			}
		}

		i++;
	}

	return TRUE;
}

unsigned __int64 match_i_id (unsigned __int64 DESC_I_ID, unsigned int * s /*out*/, btree64 * offset)
{
	int i = 0;
	unsigned __int64 result = 0;
	unsigned __int64 t;
	unsigned mask = 0xfffffffe;

	DESC_I_ID &= mask;

	//move to the leaf if not there 
	if (offset->is_leaf > 0)
	{
		while (i < offset->num_nodes)
		{
			//follow the btree structure all the way to the leaf, and find corresponding leaf.
			if(offset->key[i].i_id <= DESC_I_ID && offset->key[i + 1].i_id > DESC_I_ID)
			{

				//find node itself within leaf of a btree.
				result = match_i_id(DESC_I_ID,s,/*node*/offset->next[i]);

				return result;
			}
			i++;
		}
	}
	else
	{
		//look for a matching I-ID node in the btree structure.
		if( offset->is_leaf == 0)
		{
			while ( i < offset->num_nodes)
			{

				if(DESC_I_ID == offset->key[i].i_id)
				{
					result = offset->key[i].backpointer;  //in leaf node backpointer is offset in the file from a baginning.
					t = offset->key[i].offset;
					__asm 
					{
						push eax
						push ebx
						movzx eax, word ptr[t]
						mov ebx,s
						mov [ebx], eax
						pop eax
						pop ebx
					}

					return result;
				}
			i++;
			}
		}
	}

	return result;
}

BOOL validate_data2(HANDLE hd, DWORD number_to_read, ULONGLONG ullDiskSize, unsigned __int64 offset, int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, 
							btree64 * bbt, unsigned int parent, unsigned __int64 tree_i_id, header * h, btree64 * desc, char is32or64)
{
	DWORD read = 0;
	BOOL berr;
	int type;
	DWORD num = 0;                        
	item_0002 * _02;
	unsigned short block_sig = 0;
	unsigned int actual_size = 0;
	TCHAR * buffer_all;
	unsigned __int64 tree_offset;
	unsigned int tree_size;
	unsigned __int64 xblock_offset = 0;         
	unsigned int xblock_size = 0;                                     
	int i = 0;
	xblock * xbl; 
	btree64 * node;
	int index = -1;

	buffer_all = read_block_of_data(hd,offset,number_to_read,size,&num,h,is32or64);
	if ( buffer_all == NULL)
	{
		return FALSE;
	}

	type = validate_sector2(buffer_all,offset % number_to_read,2,size,offset,desc_i_id, h, is32or64);
	if (type == _none)
	{
		free(buffer_all);
		return FALSE;
	}
	else if (type == _01)
	{
		xbl = (xblock *) malloc(sizeof(xblock));
		if (xbl == NULL)
		{
			free(buffer_all);
			return FALSE;
		}

		//parse xblock
		berr = parse_xblock2(buffer_all,xbl,offset,number_to_read,is32or64);
		if(!berr)
		{
			free(buffer_all);
			return FALSE;
		}

		while(i < xbl->cEnt)
		{
			//process each node in xblock block.
			xblock_offset = match_i_id(xbl->bids[i],&xblock_size,bbt);
			if (xblock_offset == 0)
			{
				free(buffer_all);
				free(xbl->bids);
				free(xbl);
				return FALSE;
			}

			node = get_node(bbt,xbl->bids[i],&index);
			if(node == NULL)
			{
				free(xbl->bids);
				free(xbl);
				free(buffer_all);
				return FALSE;
			}

			berr = validate_data2(hd,number_to_read,ullDiskSize,xblock_offset,xblock_size,xbl->bids[i],node->leaf_d[index].D_ID,bbt,node->leaf_d[index].PARENT_D_ID,
					node->leaf_d[index].TREE_I_ID,h,desc,is32or64);
			if(!berr)
			{
				free(xbl->bids);
				free(xbl);
				free(buffer_all);
				return FALSE;
			}

			index = -1;
			i++;
		}

		free(xbl->bids);
		free(xbl);
	}

	switch(type)
	{
	case _bc:
		//get tree array data
		if(tree_i_id > 0)
		{
			tree_offset = match_i_id(tree_i_id,&tree_size,bbt);
			if (tree_offset > 0 && tree_size > 0)
			{
				_02 = populate_02(hd,number_to_read,tree_offset,tree_size,h,is32or64);
				if(_02 == NULL)
				{
					printf("Failed to populate subnode.\n");
					free(buffer_all);
					return FALSE;
				}
			}
			berr = read_bc_block(buffer_all,offset % number_to_read,size,desc_i_id,d_id,_02, bbt, number_to_read, hd, ullDiskSize, NULL, h, desc, is32or64);
			if(!berr)
				return FALSE;
		}
		else
		{
			berr = read_bc_block(buffer_all,offset % number_to_read,size,desc_i_id,d_id,NULL, bbt, number_to_read, hd, ullDiskSize, NULL, h, desc, is32or64);
			if(!berr)
				return FALSE;
		}		
		break;
	}

	return TRUE;
}

TCHAR * read_block_of_data (HANDLE hd, unsigned __int64 offset, DWORD number_to_read, int size, DWORD * num, header * h, char is32or64)
{
	DWORD read = 0;
	LARGE_INTEGER position;
	TCHAR * buffer_all;
	DWORD derr;
	BOOL berr;
	unsigned int full_bsize = 0;  //size of a block with possible padding and trailer.
	DWORD crc = 0;

	//calculates size of a buffer, including padding and block trailer.
	//blocks are multiples of 0x0040 and sectors are multiple of 0x0200
	full_bsize = calculate_full_block_size(size,is32or64);

	//calculate number of sectors
	*num = ((offset % number_to_read) + full_bsize) / number_to_read;
	if ( ((offset % number_to_read) + full_bsize) % number_to_read > 0)
		(*num) ++;

	buffer_all = (TCHAR *) malloc(number_to_read * (*num));
	if ( buffer_all == NULL)
	{
		printf("Failed to allocate memory for buffer_all in read_block_of_data.\n Error: %d.\n",GetLastError());
		return NULL;
	}

	position.QuadPart = /*offset - number_to_read;*/((offset / number_to_read) *  number_to_read);  
	derr = SetFilePointer(hd,position.LowPart,&position.HighPart,FILE_BEGIN);
	if (derr == INVALID_SET_FILE_POINTER)
		return NULL;
	berr = ReadFile(hd,buffer_all,(number_to_read * (*num)),&read,NULL);
	if (berr == FALSE || (number_to_read * (*num))!= read)
	{
		printf("Error in ReadFile. Error number is: %d.",GetLastError());
		return NULL;
	}

	crc = ComputeCRC(0,&buffer_all[offset % number_to_read],size);
	if(memcmp(&buffer_all[(offset % number_to_read) + (full_bsize - (is32or64 == 1 ? 0x0004 : 0x000c))],&crc,0x0004) != 0)
		return NULL;

	if(h->encryption == 0x01 && (buffer_all[offset % number_to_read] != 0x01 && buffer_all[(offset % number_to_read) + 1] != 0x01))
	{
		CryptPermute(&buffer_all[offset % number_to_read],size,FALSE);
	}

	return buffer_all;
}

int validate_sector2(TCHAR * buffer, int offset, int size, unsigned int block_size, unsigned __int64 bid_offset, unsigned __int64 desc_i_id, header * h, char is32or64)
{
	unsigned int temp = 0;
	int result;
	DWORD crc = 0;
	unsigned int full_bsize = 0;
	unsigned short sig = 0;
	unsigned mask = 0xfffffffe;

	full_bsize = calculate_full_block_size(block_size,is32or64);

	memcpy(&temp,&buffer[offset + 2],size);
	if (temp == _7c || temp == _bc)
		result = temp;
	else
		result = 0;

	if (result == 0)
	{
		memcpy(&temp,&buffer[offset],size);  //check that it is not xblock.
		if(temp == _01)
			result = temp;
		else
		{
			sig = ComputeSig((unsigned int)bid_offset,(desc_i_id &= mask));
			//check if block has correct CRC signature, and block signature then it is block of row data.
			if (memcmp(&buffer[offset + full_bsize - (is32or64 == 1 ? 0x000a : 0x000e)],&sig,2) == 0)
				result = _ok;
			else
				result = _none;
		}
	}

	return result;
}

item_0002 * populate_02(HANDLE hd, unsigned int number_to_read, unsigned __int64 tree_offset, int tree_size, header * h, char is32or64)
{
	item_0002 * _02;
	TCHAR * buffer;
	LARGE_INTEGER position;
	DWORD derr;
	BOOL berr;
	DWORD read;
	unsigned int num = 0;
	DWORD crc = 0;
	unsigned int full_bsize = 0;
	unsigned int mask = 0xfffffffe;

	//calculate size of a full block including padding and block trailer
	full_bsize = calculate_full_block_size(tree_size,is32or64);

	num = ((tree_offset % number_to_read) + full_bsize) / number_to_read;
	if ( ((tree_offset % number_to_read) + full_bsize) % number_to_read > 0)
		num ++;

	buffer = malloc(number_to_read * num);
	if (buffer == NULL)
	{
		printf("Failed to allocate memory for buffer in populate_02. Error %d.\n",GetLastError());
		return NULL;
	}

	position.QuadPart = (tree_offset / number_to_read) * number_to_read;
	derr = SetFilePointer(hd,position.LowPart,&position.HighPart,FILE_BEGIN);
	if (derr == INVALID_SET_FILE_POINTER)
	{
		return NULL;
	}
	berr = ReadFile(hd,buffer,number_to_read * num,&read,NULL);
	if (berr == FALSE || (number_to_read * num) != read)
	{
		printf("Error in ReadFile. Error numbewr is: %d.",GetLastError());
		//_02.count = 0;
		return NULL;
	}
	
	//check CRC signature for a block.
	crc = ComputeCRC(0,&buffer[tree_offset % number_to_read],tree_size);
	if(memcmp(&crc,&buffer[(tree_offset % number_to_read) + full_bsize - (is32or64 == 1 ? 0x0004 : 0x000c)],4) != 0 )
	{
		printf("Error: CRC check.\n"); 
		return NULL;
	}

	_02 = fill_02_data(buffer, tree_offset % number_to_read, is32or64);
	if (_02 == NULL)
	{
		return NULL;
	}

	free(buffer);
	return _02;
}

item_0002 * fill_02_data(TCHAR * buffer, unsigned int offset, char is32or64)
{
	unsigned int i;
	unsigned int j;
	item_0002 * item;
	int step = (is32or64 == 1 ? 4 : 8);

	item = (item_0002 *) malloc (sizeof(item_0002));
	if ( item == NULL)
	{
		printf("Error %d.\n",GetLastError());
		return NULL;
	}

	memcpy(&item->signature,&buffer[offset],1);
	if ( item->signature != 0x02)
		return NULL;
	memcpy(&item->level,&buffer[offset + 1],1);
	memcpy(&item->count,&buffer[offset + 2],2);

	item->data = (item_leaf *) malloc(sizeof(item_leaf) * item->count);
	if(item->data == NULL)
		return NULL;

	j = offset + step;
	for ( i = 0; i < item->count; i++)
	{
		memcpy(&item->data[i].id2,&buffer[j],4);
		j += step;
		memcpy(&item->data[i].i_id,&buffer[j],4);
		j += step;
		memcpy(&item->data[i].child_i_id,&buffer[j],4);
		j += step;
	}

	return item;
}

unsigned int calculate_full_block_size(unsigned int size, char is32or64)
{
	int block_trailer_size = (is32or64 == 1 ? 0x000c : 0x0010);

	//data block and trailer always present, padding only if some of first two is not multiple of 0x0040
	if((size + block_trailer_size) % 0x0040 == 0)
		return size + block_trailer_size;           //data block size + data trailer = full block size 
	else
		return size + block_trailer_size + (0x0040 - ((size + block_trailer_size) % 0x0040));  //data block size + data trailer + padding
}

BOOL read_bc_block(TCHAR * buffer, __int64 offset, int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, item_0002 * _02, btree64 * bbt, 
					DWORD number_to_read, HANDLE hd, ULONGLONG ullDiskSize, TCHAR * path, header * h, btree64 * desc, char is32or64)
{
	unsigned short bc_map_offset = 0;
	unsigned int map_count = 0;
	unsigned int b5_offset = 0;
	int start = 0, end = 0;
	const int signature = 0x02b5;
	int datasize = 0;
	unsigned int descoffset = 0;
	unsigned int temp = 0;
	BOOL berr;
	int i = 0;
	unsigned char node_type;            //will indicate what MAPI object this node is, for example: Folder, Message, etc.
	unsigned __int64 recipient_table = 0;       //offset of recepient table, if this node is Message   
	unsigned __int64 attachment_table = 0;      //offset of attachment table, if this node is Message.
	unsigned int rsize;                 //size of recipient table node.
	unsigned int asize;                 //size of attachment table node
	unsigned __int64 r_subnode_i_id = 0, a_subnode_i_id = 0; //subnodes of recipient or attachment tables.
	DWORD num;                          //number of block to read to message subnodes.
	HANDLE fl = INVALID_HANDLE_VALUE;
	TCHAR * email_name;
	TCHAR * t_buf;
	unsigned short item_type = 0;
	unsigned short reference_type = 0;
	unsigned int value = 0;
	TCHAR * a_filename;                 //if it is an attachment will hold its name.
	unsigned int a_size = 0;                //size of an attachment document.
	unsigned int a_attach_method = 0;      //Contains a MAPI-defined constant representing the way the contents of an attachment can be accessed.
	int sub_type;    
	xblock * xbl;
	unsigned __int64 r_xblock_offset = 0;
	unsigned int r_xblock_size = 0;
	TCHAR * r_xblock_buffer;
	int index = -1;

	node_type = get_node_type(d_id);

	// Email Messages. 
	if(node_type == 0x04)
	{
		email_name = (TCHAR *) malloc(sizeof(TCHAR) * MAX_PATH);
		if (email_name == NULL)
		{
			free(buffer);
			email_counter = 1;
			return FALSE;
		}
		t_buf = _getcwd(NULL,0);
		if (t_buf == NULL)
		{
			free(buffer);
			free(email_name);
			email_counter = 1;
			return FALSE;
		}
		_snprintf(email_name,MAX_PATH,"%s\\Pst%u",t_buf,pst_counter); 
		berr = CreateDirectory(email_name,NULL);
		if (berr == 0 && GetLastError() != ERROR_ALREADY_EXISTS)
		{
			printf("Failed to create %s Directory.\n",email_name);
			free(buffer);
			free(email_name);
			email_counter = 1;
			return FALSE;
		}
		free(t_buf);
		_snprintf(email_name,MAX_PATH,"%s\\Email%d",email_name,email_counter);
		temp = strlen(email_name);
		
		berr = CreateDirectory(email_name,NULL);
		if (berr == 0)
		{
			printf("Failed to create Directory for Email message %s. Error %d.\n",email_name,GetLastError());
			free(buffer);
			free(email_name);
			email_counter = 1;
			return FALSE;
		}

		_snprintf(&email_name[strlen(email_name)],MAX_PATH,"\\Email%u\0",email_counter);
		fl = CreateFile(email_name,GENERIC_WRITE|GENERIC_READ,0,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);
		if (fl == INVALID_HANDLE_VALUE)
		{
			printf("Failed to create file for Email. Error %d.\n",GetLastError());
			free(buffer);
			free(email_name);
			email_counter = 1;
			return FALSE;
		}
		printf("Created Email File at: %s.\n",email_name);
		email_counter ++;  //increment Email counter 
		email_name[temp] = '\0';
	}
	else if (node_type == 0x05)
	{
		attachment_counter ++; //increment Attachment counter 
		a_filename = (TCHAR *) malloc(sizeof(TCHAR) * MAX_PATH);
		if ( a_filename == NULL)
		{
			free(buffer);
			return FALSE;
		}

		temp = strlen(path);
		_snprintf(path,MAX_PATH,"%s\\Attachment%u",path,attachment_counter);
		fl = CreateFile(path,GENERIC_WRITE|GENERIC_READ,0,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);
		if (fl == INVALID_HANDLE_VALUE)
		{
			printf("Failed to create file for Attachment.Error: %d.\n",GetLastError());
			free(buffer);
			free(path);
			return FALSE;
		}

		path[temp] = '\0';
	}

	memcpy(&bc_map_offset,&buffer[offset],2);
	memcpy(&map_count,&buffer[offset + bc_map_offset],2);

	//needs to take care of external references for external blocks.
	memcpy(&b5_offset,&buffer[offset + 4],2);
	b5_offset >>= 4;
	//get b5 table offset
	memcpy(&start,&buffer[offset + bc_map_offset + b5_offset + 2],2);
	memcpy(&end,&buffer[offset + bc_map_offset + b5_offset + 4],2);
	//verify that we are looking at the b5 table
	memcpy(&temp,&buffer[offset + start],2);
	if (temp != signature)
	{
		free(buffer);
		if(node_type == 0x04)
		{
			free(email_name);
			CloseHandle(fl);
		}
		if(node_type == 0x05)
			free(a_filename);
		return FALSE;
	}
	memcpy(&datasize,&buffer[offset + start + 2],2);
	datasize += 2;

	memcpy(&descoffset,&buffer[offset + start + 4],2);
	descoffset >>= 4;

	//here is real MAPI elements will start in bc block
	memcpy(&start,&buffer[offset + bc_map_offset + descoffset + 2],2);
	memcpy(&end,&buffer[offset + bc_map_offset + descoffset + 4],2);

	while( i < (end - start) / datasize)
	{
		memcpy(&item_type,&buffer[offset + start + i * datasize],2);
		memcpy(&reference_type,&buffer[offset + start + i * datasize + 2],2);
		memcpy(&value,&buffer[offset + start + i * datasize + 4],4);

		if(node_type == 0x05)
		{
			if(item_type == 0x0e20 && reference_type == 0x0003) //PIDTagAttachSize
			{
				a_size = value;
				i++;
				continue;
			}
			if(item_type == 0x3705 && reference_type == 0x0003) //PIDTagAttachMethod
			{
				a_attach_method = value; //?
				i++;
				continue;
			}
			berr = get_MAPI_element(buffer, fl, bc_map_offset, offset, node_type, _02, bbt, number_to_read, hd, item_type, reference_type, value, 
				a_filename, h, is32or64, NULL, NULL, NULL);
		}
		else if (node_type == 0x04)
		{
			berr = get_MAPI_element(buffer, fl, bc_map_offset, offset, node_type, _02, bbt, number_to_read, hd, item_type, reference_type, value, NULL, h, is32or64,
				NULL,NULL,NULL);
		}
		else
		{
			break;   //not interested in other structures at this point.
		}
		if (!berr)
		{
			printf("Warning: Failed to parse this PC.\n");
		}

		i++;
	}

	//process subnodes of a Message.
	if ( _02 != NULL && node_type == 0x04)
	{
		//at this point we can analize subnode if present for a given node.
		berr = parse_subnode(_02, bbt,&recipient_table,&rsize,&attachment_table,&asize,&r_subnode_i_id,&a_subnode_i_id);
		if(!berr)
		{
			printf("Possible delay created EMail Message. No Recepient table.\n");
			goto exit;
		}

		if( recipient_table > 0 )
		{
			//read recipient table data. It must to be TC and must to be present in a Message.
			free(buffer);
			buffer = read_block_of_data(hd,recipient_table,number_to_read,rsize,&num,h,is32or64);
			if(buffer == NULL)
			{
				CloseHandle(fl);
				free(email_name);
				free(_02->data);
				free(_02);
				return FALSE;
			}

			sub_type = get_block_type(buffer,recipient_table % number_to_read);
			if (sub_type == _01)
			{
				xbl = (xblock*) malloc(sizeof(xblock));
				if(xbl == NULL)
				{
					CloseHandle(fl);
					free(email_name);
					free(_02->data);
					free(_02);
					printf("Failed to parse recepient table.\n");
					return FALSE;
				}

				berr = parse_xblock2(buffer,xbl,recipient_table,number_to_read,is32or64);
				if(!berr)
				{
					CloseHandle(fl);
					free(email_name);
					free(_02->data);
					free(_02);
					printf("Failed to parse recepient table.\n");
					free(xbl);
					return FALSE;
				}
				//get just first data block here
				r_xblock_offset = match_i_id(xbl->bids[0],&r_xblock_size,bbt);
				if(!r_xblock_offset)
				{
					CloseHandle(fl);
					free(email_name);
					free(_02->data);
					free(_02);
					printf("Failed to parse recepient table.\n");
					free(xbl->bids);
					free(xbl);
					return FALSE;
				}
				r_xblock_buffer = read_external_data(r_xblock_size,r_xblock_offset,number_to_read,hd,h);
				if(r_xblock_buffer == NULL)
				{
					CloseHandle(fl);
					free(email_name);
					free(_02->data);
					free(_02);
					printf("Failed to parse recepient table.\n");
					free(xbl->bids);
					free(xbl);
					return FALSE;
				}

				if(h->encryption == 0x01)
				{
					CryptPermute(&r_xblock_buffer[r_xblock_offset % number_to_read],r_xblock_size,FALSE);
				}

				berr = read_7c_block(hd,r_xblock_buffer,number_to_read,ullDiskSize,r_xblock_offset % number_to_read,r_xblock_size,recipient_table,0,fl,bbt,0x12,
							email_name,NULL,r_subnode_i_id,h,desc,is32or64,xbl);
				if(!berr)
				{
					CloseHandle(fl);
					free(email_name);
					free(_02->data);
					free(_02);
					printf("Failed to parse recepient table.\n");
					free(xbl->bids);
					free(xbl);
					return FALSE;
				}

				free(xbl->bids);
				free(xbl);
			}
			else
			{
				berr = read_7c_block(hd,buffer,number_to_read,ullDiskSize,recipient_table % number_to_read,rsize,desc_i_id,d_id,fl,bbt,0x12,email_name, _02,
					r_subnode_i_id,h,desc,is32or64,NULL);
				if(!berr)
				{
					free(buffer);
					free(email_name);
					CloseHandle(fl);
					free(_02->data);
					free(_02);
					return FALSE;
				}
			}
		}
		if (attachment_table > 0)
		{
			free(buffer);
			buffer = read_block_of_data(hd,attachment_table,number_to_read,asize,&num,h,is32or64);
			if(buffer == NULL)
			{
				free(email_name);
				CloseHandle(fl);
				free(_02->data);
				free(_02);
				return FALSE;
			}
			berr = read_7c_block(hd,buffer,number_to_read,ullDiskSize,attachment_table % number_to_read,asize,desc_i_id,d_id,fl,bbt,0x11,email_name,_02,
				a_subnode_i_id,h,desc,is32or64,NULL);
			if(!berr)
			{
				free(buffer);
				CloseHandle(fl);
				free(email_name);
				free(_02->data);
				free(_02);
				return FALSE;
			}
			
		}

	}//end if

exit:
	if(node_type == 0x04)
		free(email_name);
	CloseHandle(fl);
	if(node_type == 0x05)
		free(a_filename);
	free(buffer);
	if ( _02 != NULL)
	{
		free(_02->data);
		free(_02);
	}

	return TRUE;
}

BOOL read_7c_block(HANDLE hd, TCHAR * buffer, DWORD number_to_read, ULONGLONG ullDiskSize, int offset, 
				   int size, unsigned __int64 desc_i_id, unsigned __int64 d_id, HANDLE fl, btree64 * bbt, unsigned char node_type, TCHAR * email_name, item_0002 * _02,
				   unsigned __int64 subnode, header * h, btree64 * desc, char is32or64, xblock * xbl)
{
	int _7c_descriptor_offset = 0;
	unsigned int map_count = 0;
	const int signature = 0x7cec;
	unsigned int _7c_offset = 0;
	unsigned int start = 0, end = 0;
	_07_header * table_header;
	_07_rowindex * row_index;
	_07_coldesc * col_desc;
	unsigned short wPropID;
	unsigned short wPropType;
	unsigned int dwValueHNid;
	unsigned int row_count;
	//int heapstatus;
	unsigned int i, j ,k;
	unsigned int temp = 0;
	unsigned long long value = 0;
	BOOL berr;
	unsigned __int64 aoffset = 0;     //offset of an attachment if TC is an attachment table.
	unsigned int asize = 0;       //size of a block that contains attachment.
	DWORD num;
	TCHAR * attachment_buffer;
	unsigned __int64 tree_offset = 0;
	unsigned int tree_size = 0;
	item_0002 * attach_02;            //will keep attachment data.
	item_0002 * subnode_02;           //will keep subnode data
	TCHAR * subnode_buffer; 
	unsigned __int64 subnode_offset = 0;  //offset of an subnode if it's present for given TC
	unsigned int subnode_size = 0;    //size of an subnode if it's present for given TC
	unsigned int nid_type = 0;        //will indicate if this node within TC is an internal node or external  
	unsigned int data_block = 0;
	unsigned __int64 * additional_offset = 0;
	unsigned int additional_size = 0;
	TCHAR ** additional_buffers;
	unsigned short * additional_block_header;

	//parse additional data block if present.
	if (xbl != NULL)
	{
		additional_buffers = (TCHAR **) malloc(sizeof(TCHAR*) * (xbl->cEnt - 1));
		if(additional_buffers == NULL)
		{
			printf("Failed to parse extra data blocks.\n");
			return FALSE;
		}

		additional_offset = (unsigned __int64*) malloc(sizeof(__int64) * (xbl->cEnt - 1));
		if (additional_offset == NULL)
		{
			printf("Failed to parse extra data blocks.\n");
			free(additional_buffers);
			return FALSE;
		}
		additional_block_header = (unsigned short*) malloc(sizeof(short) * (xbl->cEnt - 1));
		if(additional_block_header == NULL)
		{
			printf("Failed to parse extra data blocks.\n");
			free(additional_buffers);
			free(additional_offset);
			return FALSE;
		}

		//block at offset 0 is already contained in buffer variable.
		for(i = 1; i < xbl->cEnt; i ++)
		{
			additional_offset[i-1] = match_i_id(xbl->bids[i],&additional_size,bbt);
			if (additional_offset == 0)
			{
				printf("Failed to parse extra data blocks.\n");
				free(additional_buffers);
				free(additional_offset);
				free(additional_block_header);
				return FALSE;
			}
			additional_buffers[i-1] = (TCHAR*) malloc(sizeof(TCHAR) * additional_size);
			if(additional_buffers[i-1] == NULL)
			{
				printf("Failed to parse extra data blocks.\n");
				free(additional_buffers);
				free(additional_offset);
				free(additional_block_header);
				return FALSE;
			}
			additional_buffers[i-1] = read_external_data(additional_size,additional_offset[i-1],number_to_read,hd,h);
			if (additional_buffers[i - 1] == NULL)
			{
				printf("Failed to parse extra data blocks.\n");
				free(additional_buffers);
				free(additional_offset);
				free(additional_block_header);
				return FALSE;
			}

			if(h->encryption == 0x01)
			{
				CryptPermute(&additional_buffers[i - 1][additional_offset[i-1] % number_to_read],additional_size,FALSE);
			}

			memcpy(&additional_block_header[i-1],&additional_buffers[i-1][additional_offset[i-1] % number_to_read],2);
		}
	}

	//parse subnode data if it's present. For example data for row matrix can be stored in external block.
	if(subnode > 0)
	{
		subnode_offset = match_i_id(subnode,&subnode_size,bbt);
		if(subnode_offset == 0)
		{
			printf("Failed to get offset of TC subnode.\n");
			free(additional_block_header);
			for (i = 0; i < xbl->cEnt - (unsigned int)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
			return FALSE;
		}

		subnode_02 = populate_02(hd,number_to_read,subnode_offset,subnode_size,h,is32or64);
		if(subnode_02 == NULL)
		{
			printf("Failed to populate subnode of an attachment.\n");
			return FALSE;
		}
	}

	memcpy(&_7c_descriptor_offset,&buffer[offset],2);
	memcpy(&map_count,&buffer[offset + _7c_descriptor_offset],2);

	//needs to take care of external references for external blocks.
	memcpy(&_7c_offset,&buffer[offset + 4],2);
	_7c_offset >>= 4;

	//check that current block is laying within the current buffer, if not read additional buffer with continuation for the block data.
	memcpy(&temp,&buffer[offset + 2],2);
	if (temp != signature)
	{
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}

	memcpy(&start,&buffer[offset + _7c_descriptor_offset + _7c_offset + 2],2);
	table_header = (_07_header *) malloc (sizeof(_07_header));
	if(table_header == NULL)
	{
		printf("Failed to allocate memory for _07_header in read_07_block. Error: %d.\n",GetLastError());
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}
	memcpy(&table_header->signature,&buffer[offset + start],1);
	if (table_header->signature != 0x7c)
	{
		free(table_header);
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}
	memcpy(&table_header->item_count,&buffer[offset + start + 1],1);
	memcpy(&table_header->_4b,&buffer[offset + start + 2],2);
	memcpy(&table_header->_2b,&buffer[offset + start + 4],2);
	memcpy(&table_header->_1b,&buffer[offset + start + 6],2);
	memcpy(&table_header->record_size,&buffer[offset + start + 8],2);
	memcpy(&table_header->b5_offset,&buffer[offset + start + 0xa],4);
	memcpy(&table_header->index_2_offset,&buffer[offset + start + 0xe],4);

	//read column descriptors data.
	temp = offset + start + 0xe + 8;
	col_desc = (_07_coldesc *) malloc(sizeof(_07_coldesc) * table_header->item_count);
	if (col_desc == NULL)
	{
		free(table_header);
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}
	for(i = 0;i < table_header->item_count; i++)
	{
		memcpy(&col_desc[i].wPropID,&buffer[temp],2);
		temp += 2;
		memcpy(&col_desc[i].wPropType,&buffer[temp],2);
		temp += 2;
		memcpy(&col_desc[i].ibData,&buffer[temp],2);
		temp += 2;
		memcpy(&col_desc[i].cbData,&buffer[temp],1);
		temp ++;
		memcpy(&col_desc[i].iBit,&buffer[temp],1);
		temp ++;
	}

	//populate b5 block
	temp = (table_header->b5_offset & 0x0000ffff) >> 4;
	data_block = (table_header->b5_offset & 0xffff0000) << 15;
	memcpy(&temp,&buffer[offset + _7c_descriptor_offset + temp + 2],2);
	memcpy(&wPropID,&buffer[offset + temp],2);
	if (wPropID != 0x04b5)
	{
		free(table_header);
		free(col_desc);
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}
	memcpy(&wPropType,&buffer[offset + temp + 2],2);
	memcpy(&dwValueHNid, & buffer[offset + temp + 4],4);

	//record count in of tables 
	temp = (dwValueHNid & 0x0000ffff) >> 4;
	data_block = (dwValueHNid & 0xffff0000) >> 16;
	if (data_block == 0)
	{
		memcpy(&start, &buffer[offset + _7c_descriptor_offset + temp + 2],2);
		memcpy(&end, &buffer[offset + _7c_descriptor_offset + temp + 4],2);
	}
	else
	{
		memcpy(&start, &additional_buffers[data_block - 1][(additional_offset[data_block - 1] % number_to_read) + additional_block_header[data_block - 1] + temp + 2],2);
		memcpy(&end, &additional_buffers[data_block - 1][(additional_offset[data_block - 1] % number_to_read) + additional_block_header[data_block - 1] + temp + 4],2);
	}
	row_count = (end - start) /(4 + wPropType);
	if (row_count == 0)
	{
		printf("Row count is 0.\n");
	}

    row_index = (_07_rowindex *) malloc(sizeof(_07_rowindex) * row_count);
	if (row_index == NULL)
	{
		free(table_header);
		free(col_desc);
		if(xbl != NULL)
		{
			free(additional_offset);
			free(additional_block_header);
			for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
				free(additional_buffers[i]);
			free(additional_buffers);
		}
		return FALSE;
	}
	for(i = 0,temp = 0; i < row_count; i++, temp += 4 + wPropType)
	{
		if(data_block)
		{
			memcpy(&row_index[i].dwRowID,&additional_buffers[data_block - 1][ start + temp],4);
			memcpy(&row_index[i].dwRowIndex,&additional_buffers[data_block - 1][start + temp + 4],2);
		}
		else
		{
			memcpy(&row_index[i].dwRowID,&buffer[offset + start + temp],4);
			memcpy(&row_index[i].dwRowIndex,&buffer[offset + start + temp + 4],2);
		}
	}

	//read data in row matrix
	nid_type = get_node_type(table_header->index_2_offset);
	if (!nid_type)
	{
		temp = (table_header->index_2_offset >> 4) + 2; 
		//row matrix start at this location
		memcpy(&start,&buffer[offset + _7c_descriptor_offset + temp],2);
		memcpy(&end,&buffer[offset + _7c_descriptor_offset + temp + 2],2);
	}
	//row matrix is stored in external node.
	else if(nid_type == nid_type_ltp)
	{
		subnode_offset = get_external_offset64(table_header->index_2_offset,subnode_02,bbt,&subnode_size);
		if (subnode_offset == 0)
		{
			free(table_header);
			free(col_desc);
			free(row_index);
			if(xbl != NULL)
			{
				free(additional_offset);
				free(additional_block_header);
				for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
					free(additional_buffers[i]);
				free(additional_buffers);
			}
			return FALSE;
		}
		subnode_buffer = read_external_data(subnode_size,subnode_offset,number_to_read,hd,h);
		if(subnode_buffer == NULL)
		{
			printf("Failed to get buffer for external node.\n");
			free(table_header);
			free(col_desc);
			free(row_index);
			if(xbl != NULL)
			{
				free(additional_offset);
				free(additional_block_header);
				for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
					free(additional_buffers[i]);
				free(additional_buffers);
			}
			return FALSE;
		}
		if(h->encryption == 0x01)
		{
			CryptPermute(&subnode_buffer[subnode_offset % number_to_read],subnode_size,FALSE);
		}
		temp = subnode_offset % number_to_read; //will hold offset where external block starts within a buffer that was read.
	}

	//find matching value for the entry in the col_desc structure.
	for ( j = 0; j < row_count; j ++)
	{
		//step will be determined by the size of an item in the col_desc structure
		//order at which item are parsed is determined by the way items appear in col_desc structure.
		for ( i = 0, k = 0; i < table_header->item_count && k < table_header->record_size; i++ )
		{
			if (nid_type == 0)
				memcpy(&value,&buffer[offset + start + col_desc[i].ibData + ( j * table_header->record_size)],col_desc[i].cbData);
			else
				memcpy(&value,&subnode_buffer[temp + col_desc[i].ibData + ( j * table_header->record_size)],col_desc[i].cbData);
			k += col_desc[i].cbData;

			//here size of value is 8 bytes, but we really only interested in values that are 4 bytes
			if (xbl != NULL)
			{
				berr = get_MAPI_element(buffer,fl,_7c_descriptor_offset,offset,node_type,subnode > 0 ? subnode_02 : NULL,
					bbt,number_to_read,hd,col_desc[i].wPropType,col_desc[i].wPropID,(unsigned int)value,NULL,h,is32or64,
					additional_block_header,additional_buffers,additional_offset);
			}
			else
			{
				berr = get_MAPI_element(buffer,fl,_7c_descriptor_offset,offset,node_type,subnode > 0 ? subnode_02 : NULL,
					bbt,number_to_read,hd,col_desc[i].wPropType,col_desc[i].wPropID,(unsigned int)value,NULL,h,is32or64,
					NULL,NULL,NULL);
			}
			if(!berr)
			{
				printf("Warning: failed to read TC property.\n");
			}
		}

		//process attachment nodes here
		//dwRowID in attachment table corresponds to id2 in _02
		if (node_type == 0x11)
		{
			i = 0;
			while( i < _02->count)
			{
				if( row_index[j].dwRowID == _02->data[i].id2)
				{
					aoffset = match_i_id(_02->data[i].i_id,&asize,bbt);
					if ( aoffset > 0)
					{
						attachment_buffer = read_block_of_data(hd,aoffset,number_to_read,asize,&num,h,is32or64);
						if (attachment_buffer == NULL)
						{
							printf("Failed to get an attachment.\n");
							if (nid_type == nid_type_ltp)
								free(subnode_buffer);
							free(table_header);
							free(row_index);
							free(col_desc);
							if(subnode > 0)
							{
								free(subnode_02->data);
								free(subnode_02);
							}
							if(xbl != NULL)
							{
								free(additional_offset);
								free(additional_block_header);
								for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
									free(additional_buffers[i]);
								free(additional_buffers);
							}
							return FALSE;
						}

						//attachment node has a subnode, which will contain attachment data.
						//before processing attachment PC, we have to get enougn data about its subnode.
						if(_02->data[i].child_i_id > 0)
						{
							tree_offset = match_i_id(_02->data[i].child_i_id,&tree_size,bbt);
							if(tree_offset > 0)
							{
								attach_02 = populate_02(hd,number_to_read,tree_offset,tree_size,h,is32or64);
								if(attach_02 == NULL)
								{
									printf("Failed to populate subnode of an attachment.\n");
									if (nid_type == nid_type_ltp)
										free(subnode_buffer);
									free(table_header);
									free(row_index);
									free(col_desc);
									free(attachment_buffer);
									if(subnode > 0)
									{
										free(subnode_02->data);
										free(subnode_02);
									}
									if(xbl != NULL)
									{
										free(additional_offset);
										free(additional_block_header);
										for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
											free(additional_buffers[i]);
										free(additional_buffers);
									}
									return FALSE;
								}
							}
						}
						else
						{
							attach_02 = NULL;
						}

						berr = read_bc_block(attachment_buffer,aoffset % number_to_read,asize,desc_i_id,row_index[j].dwRowID,
												attach_02,bbt,number_to_read,hd,ullDiskSize,email_name,h,desc,is32or64);
						if (!berr)
						{
							printf("Failed to read data from an attachment block.\n");
							if (nid_type == nid_type_ltp)
								free(subnode_buffer);
							free(table_header);
							free(row_index);
							free(col_desc);
							if(subnode > 0)
							{
								free(subnode_02->data);
								free(subnode_02);
							}
							if(xbl != NULL)
							{
								free(additional_offset);
								free(additional_block_header);
								for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
									free(additional_buffers[i]);
								free(additional_buffers);
							}
							return FALSE;
						}
					}//end if
					else
					{
						printf("Failed to get an offset of an attachment.\n");
						if (nid_type == nid_type_ltp)
							free(subnode_buffer);
						free(table_header);
						free(col_desc);
						free(row_index);
						if(subnode > 0)
						{
							free(subnode_02->data);
							free(subnode_02);
						}
						if(xbl != NULL)
						{
							free(additional_offset);
							free(additional_block_header);
							for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
								free(additional_buffers[i]);
							free(additional_buffers);
						}
						return FALSE;
					}
				}
				i ++;
			}

		}
		k = 0;
	}

	if (nid_type == nid_type_ltp)
		free(subnode_buffer);
	free(table_header);
	free(row_index);
	free(col_desc);
	if(subnode > 0)
	{
		free(subnode_02->data);
		free(subnode_02);
	}
	if(xbl != NULL)
	{
		free(additional_offset);
		free(additional_block_header);
		for(i = 0; i < xbl->cEnt - (unsigned)1; i++)
			free(additional_buffers[i]);
		free(additional_buffers);
	}

	return TRUE;
}

BOOL parse_subnode (item_0002 * _02, btree64 * bbt,/*out params*/unsigned __int64 * recipient_table, unsigned int * rsize, 
					unsigned __int64 * attachment_table, unsigned int * asize, unsigned __int64 * r_subnode_i_id, unsigned __int64 * a_subnode_i_id)
{
	unsigned char type;
	int i = 0;
	int counter = 0;

	for (i = 0; i < _02->count; i++)
	{
		//recipient table is 0x12 and attachment table is 0x11.
		type = get_node_type(_02->data[i].id2);
		if(type == 0x12)  //this entry is always present for Messages according to documentation, but not always present.
		{
			*recipient_table = match_i_id(_02->data[i].i_id,rsize,bbt);
			if (*recipient_table > 0)
				counter ++;
			*r_subnode_i_id = _02->data[i].child_i_id;
		}
		else if(type == 0x11) //Attachment table is optional entry
		{
			*attachment_table = match_i_id(_02->data[i].i_id,asize,bbt);
			if(*attachment_table > 0)
				counter ++;
			*a_subnode_i_id = _02->data[i].child_i_id;
		}
	}

	if (counter == 0)  //at very least message has to have recipient table. 
		return FALSE;

	return TRUE;
}

BOOL get_MAPI_element(TCHAR * buffer, HANDLE fl, unsigned short map_offset, unsigned __int64 offset, unsigned char node_type, item_0002 * _02, 
					  btree64 * bbt, DWORD number_to_read, HANDLE hd, unsigned short item_type, unsigned short reference_type, 
					  unsigned int value, /*out*/TCHAR * var_string, header * h, char is32or64, unsigned short * additional_block_header, TCHAR ** additional_buffers,
					  unsigned __int64 * additional_offset)
{
	BOOL berr;
	BOOL if_internal_reference;
	unsigned int start = 0, finish = 0;
	unsigned short temp = 0;
	TCHAR wtext[255];
	unsigned short data_block = 0;

	//according to mapitags.h we only interested in properties with item_type equal less then 0x3fff
	if (item_type <= 0x3fff)
	{
		if ( value << 27 == 0)
			if_internal_reference = TRUE;
		else
			if_internal_reference = FALSE;

		if (if_internal_reference && (reference_type == PT_UNICODE || reference_type == PT_STRING8))
		{
			//get starting and ending offset of a data within data block
			data_block = (value & 0xffff0000) >> 16;
			if (data_block)
			{
				memcpy(&start,&additional_buffers[data_block - 1][(additional_offset[data_block - 1] % number_to_read) + 
					additional_block_header[data_block - 1] + ((value & 0x0000ffff) >> 4) + 2],2);
				memcpy(&finish,&additional_buffers[data_block - 1][(additional_offset[data_block - 1] % number_to_read) + 
					additional_block_header[data_block - 1] + ((value & 0x0000ffff) >> 4) + 4],2);
			}
			else
			{
				memcpy(&start,&buffer[offset + map_offset + (value >> 4) + 2],2);
				memcpy(&finish,&buffer[offset + map_offset + (value >> 4) + 4],2);
			}
		}

		if (node_type == 0x04)  //Email Object
		{
			if (reference_type == PT_UNICODE || reference_type == PT_STRING8)
			{
				if(item_type == 0x001a || item_type == 0x0040 || item_type == 0x0042 || item_type == 0x0065 || item_type == 0x0076 || 
					item_type == 0x0c1a || item_type == 0x0c1f || item_type == 0x0e04 || item_type == 0x1000 || item_type == 0x1013)
				{
					switch(item_type)
					{
						case 0x001a:
							//Doubleheck that it is an EMail message.
							memcpy(wtext,&buffer[offset + start],finish - start);
							wtext[finish - start] = '\0';
							if (is32or64 == 1)
							{
								if (memcmp(wtext,"IPM.Note\0",0x08) != 0)
									return FALSE;
								else 
									return TRUE;
							}
							else if(is32or64 == 2)
							{
								if (memcmp(wtext,"I\0P\0M\0.\0N\0o\0t\0e\0",0x10) != 0)
								//if(wcsncmp(buffer_to_write,L"IPM.Note",0x08) != 0)
									return FALSE;
								else 
									return TRUE;
							}
						break;
						case 0x0040: //PIDTagReceivedByName
							strncpy(wtext,"Receiver's Display Name: \0",255);
						break;
						case 0x0042: //PIDTagSentByName
							strncpy(wtext,"Sender's Display Name: \0",255);
						break;
						case 0x0065: //PIDTagSentRepresentingEmailAddress
							strncpy(wtext,"Sent as Email address: \0",255);
						break;
						case 0x0076: //PIDTagReceivedByEmailAddress
							strncpy(wtext,"Received from Email address: \0",255);
						break;
						case 0x0c1a: //PIDTagSenderName
							strncpy(wtext,"Sender Name: \0",255);
						break;
						case 0x0c1f: //PIDTagSenderEmailAddress
							strncpy(wtext,"Sender Email Address: \0",255);
						break;
						case 0x0e04: //PIDTagDisplayTo
							strncpy(wtext,"To: \0",255);
						break;
						case 0x1000: //PIDTagBody
							strncpy(wtext,"Email body: \0",255);
						break;
						case 0x1013: //PIDTagBodyHTML
							strncpy(wtext,"Email's HTML body: \0",255);
						break;
					}//end switch

					if (if_internal_reference)
					{
						berr = write_message_data(buffer,start,finish,wtext,reference_type,value,fl,offset);
						if (!berr)
							return FALSE;
					}
					//if its subnode
					else
					{
						berr = get_external_data(value,_02,bbt,fl,number_to_read,hd,reference_type,wtext,h, is32or64);
						if (!berr)
						{
							printf("Failed to read external data.\n");
							return FALSE;
						}
					}
				}//end if
 			}//end if PT_UNICODE

		}//end if message
		
		if (node_type == 0x12)  //Recipient Table
		{
			if (reference_type == PT_UNICODE || reference_type == PT_STRING8)
			{
				if(item_type >= 0x3001 && item_type <= 0x3003)
				{
					switch(item_type)
					{
						case 0x3001: //PIDTagDisplayName
							strncpy(wtext,"Recipient Dispaly Name: \0",255);
						break;
						case 0x3002: //PIDTagAddressType
							strncpy(wtext,"Recipient Address Type: \0",255);
						break;
						case 0x3003: //PIDTagEmailAddress
							strncpy(wtext,"Recipient Email Address: \0",255);
						break;
					}//end switch

					if (if_internal_reference)
					{
						berr = write_message_data(data_block == 0 ? buffer : additional_buffers[data_block - 1],
							start,finish,wtext,reference_type,value,fl,data_block == 0 ? offset : (additional_offset[data_block - 1] % number_to_read));
						if (!berr)
							return FALSE;
					}
					//if its subnode
					else
					{
						berr = get_external_data(value,_02,bbt,fl,number_to_read,hd,reference_type,wtext,h,is32or64);
						if (!berr)
						{
							printf("Failed to read external data.\n");
							return FALSE;
						}
					}
				}//end if
			}//end if
		}//end if

		if(node_type == 0x11) //Attachment table
		{
			switch(item_type)
			{
				case 0x3704: //PIDTagFilename
					if(reference_type == PT_UNICODE || reference_type == PT_STRING8)
					{
						if (if_internal_reference)
						{
							berr = write_message_data(buffer,start,finish,"Attachment: ",reference_type,value,fl,offset);
							if (!berr)
								return FALSE;
						}
						//if its subnode
						else
						{
							berr = get_external_data(value,_02,bbt,fl,number_to_read,hd,reference_type,"Attachment: ",h, is32or64);
							if (!berr)
							{
								printf("Failed to read external data.\n");
								return FALSE;
							}
						}
					}
				break;
			}//end switch
		}//end if

		if (node_type == 0x05) //Attachment
		{
			switch(item_type)
			{
			case 0x3701: //PIDTagAttachDataBinary 
				if ( reference_type == PT_UNICODE || reference_type == PT_BINARY || reference_type == PT_STRING8)
				{
						if (if_internal_reference)
						{
							berr = write_message_data(buffer,start,finish,"Attachment: ",reference_type,value,fl,offset);
							if (!berr)
								return FALSE;
						}
						//if its subnode
						else
						{
							berr = get_external_data(value,_02,bbt,fl,number_to_read,hd,reference_type,"Attachment: ",h, is32or64);
							if (!berr)
							{
								printf("Failed to read external data.\n");
								return FALSE;
							}
						}
				}
			break;
			}//end switch
		}//end if
	}//end if

	return TRUE;
}

TCHAR * read_external_data (unsigned int size, unsigned __int64 offset, DWORD number_to_read, HANDLE hd,header * h)
{
	TCHAR * buffer;
	unsigned int num;         
	LARGE_INTEGER pos; 
	DWORD derr;
	BOOL berr;
	DWORD read = 0;
	//DWORD crc = 0;

	pos.QuadPart = 0;
	derr = SetFilePointerTo(hd,pos,FILE_BEGIN);
	if ( derr == INVALID_SET_FILE_POINTER)
		return NULL;

	num = ((offset % number_to_read) + size) / number_to_read;
	if ( ((offset % number_to_read) + size) % number_to_read > 0)
		num ++;

	buffer = (TCHAR *) malloc(sizeof(TCHAR) * num * number_to_read);
	if ( buffer == NULL)
		return NULL;

	if ( offset % number_to_read == 0)
		pos.QuadPart = offset;
	else
		pos.QuadPart = offset - (offset % number_to_read);

	derr = SetFilePointerTo(hd,pos,FILE_CURRENT);
	if (derr == INVALID_SET_FILE_POINTER)
		return FALSE;
	berr = ReadFile(hd,buffer,num * number_to_read,&read,NULL);
	if ( berr == FALSE || num * number_to_read != read)
		return NULL;

	return buffer;
}

unsigned __int64 get_external_offset64(unsigned int value, item_0002 * _02, btree64 * bbt, /*out*/unsigned int * size)
{
	unsigned int i = 0;
	unsigned __int64 result = 0;
	unsigned __int64 bbt_nid = 0;
	unsigned int mask = 0xfffffffe;

	//first, find index of bid in bbt corresponding to this nid in _02 strcuture.
	while( i < _02->count)
	{
		if (_02->data[i].id2 == value)
		{
			bbt_nid = _02->data[i].i_id;
			break;
		}
		i++;
	}
	//searched through all SLBLOCK and found no matching id2.
	if (i == _02->count && bbt_nid == 0)
		return result;

	//fix bid before search, it lsb is 1 change it to 0 to find a match in bbt.
	bbt_nid &= mask;

	result = match_i_id(bbt_nid,size,bbt);

	return result;
}

BOOL get_external_data(unsigned int value, item_0002 * _02, btree64 * bbt, HANDLE fl, DWORD number_to_read, HANDLE hd, unsigned int reference_type, TCHAR * description,
					   header * h, char is32or64)
{
	unsigned __int64 external_offset = 0;         //offset of external subnode, if present
	unsigned int size = 0;                    //size of data in external node.
	TCHAR * external_buffer;                  //will contain external data buffer.
	xblock * xbl;                             
	int i = 0;
	unsigned short t;
	BOOL berr;
	unsigned  short xxbl_cEnt = 0;
	unsigned int xxblk_totalBytes = 0;
	unsigned __int64 xxblock_offset = 0; 
	TCHAR * xxblock_buffer;                    
	unsigned __int64 bid = 0;
	const unsigned int bid_size = 4;
	const unsigned int xxblock_bid_start = 8; 

	//if bid has lsb set to 1 set it to 0 and search bbt for a matching node.
	if ( (external_offset = get_external_offset64(value ,_02,bbt,&size)) == 0)
		return FALSE;
	external_buffer = read_external_data(size,external_offset,number_to_read,hd,h);
	if (external_buffer == NULL)
	{
		printf("Failed to read data in external subnode.\n");
		return FALSE;
	}

	//if data is large and needs to be stored in xblock structure
	memcpy(&t,&external_buffer[external_offset % number_to_read],2);
	if ( t == _01)
	{
		xbl = (xblock*) malloc (sizeof(xblock));
		if(xbl == NULL)
		{
			free(external_buffer);
			free(xbl);
			return FALSE;
		}

		berr = parse_xblock(value,bbt,fl,number_to_read,hd,reference_type,description,xbl,external_buffer,external_offset,size,h,is32or64);
		if(!berr)
		{
			free(xbl);
			return FALSE;
		}

		free(xbl);
	}
	//if data is even bigger nad needs to be stored in xxblock structure.
	else if ( t == 0x0201)
	{
		memcpy(&xxbl_cEnt,&external_buffer[(external_offset % number_to_read) + 2],2);
		memcpy(&xxblk_totalBytes,&external_buffer[(external_offset % number_to_read) + 4],4);

		if(xxbl_cEnt > 0)
		{
			//parse each xblock.
			for ( i = 0; i < xxbl_cEnt; i++)
			{
				memcpy(&bid,&external_buffer[(external_offset % number_to_read) + xxblock_bid_start + (bid_size * i)],bid_size);
				if (bid > 0)
				{
					if ((xxblock_offset  = match_i_id(bid,&size,bbt)) == 0)
						return FALSE;
					xxblock_buffer = read_external_data(size,xxblock_offset,number_to_read,hd,h);
					if (xxblock_buffer == NULL)
					{
						printf("Failed to read data in external subnode.\n");
						return FALSE;
					}

					xbl = (xblock *) malloc(sizeof(xblock));
					if(xbl == NULL)
					{
						free(external_buffer);
						return FALSE;
					}

					berr = parse_xblock(value,bbt,fl,number_to_read,hd,reference_type,description,xbl,xxblock_buffer,xxblock_offset,size,h,is32or64);
					if(!berr)
					{
						free(xbl);
						return FALSE;
					}

					free(xbl);
				}
				else
					return FALSE;
			}
			free(external_buffer);
		}
		else
		{
			printf("Failed to parse xxblock.\n");
			return FALSE;
		}
	}
	else
	{
		if (h->encryption == 0x01)
		{
			CryptPermute(&external_buffer[external_offset % number_to_read],size,FALSE);
		}

		berr = write_message_data(external_buffer,0,size /*+ (external_offset % number_to_read)*/,description,reference_type,value,fl,
						 external_offset % number_to_read);
		if(!berr)
		{
			free(external_buffer);
			return FALSE;
		}
	}

	return TRUE;
}

BOOL write_message_data (TCHAR * buffer, unsigned int start, unsigned int finish, TCHAR * description, unsigned short reference_type,
					unsigned int value, HANDLE fl, unsigned __int64 offset)
{
	BOOL berr;
	DWORD writen;
	TCHAR * end_stream = "\r\n";

	if ( reference_type == PT_UNICODE || reference_type == PT_STRING8)
	{
		berr = WriteFile(fl,description,strlen(description),&writen,NULL);
		if ( berr == FALSE || writen != strlen(description))
		{
			printf("Failed to write to the fl file. Error: %d.\n",GetLastError());
			return FALSE;
		}

		berr = WriteFile(fl,&buffer[offset + start],finish - start, &writen, NULL);
		if ( berr == FALSE || writen != finish - start)
		{
			printf("Failed to write to the fl file. Error: %d.\n",GetLastError());
			return FALSE;
		}

		berr = WriteFile(fl,end_stream,2,&writen,NULL);
		if (berr == FALSE || writen != 2)
		{
			printf("Failed to write to the fl file. Error: %d.\n",GetLastError());
			return FALSE;
		}
	}
	else if ( reference_type == PT_BINARY)
	{
		berr = WriteFile(fl,&buffer[offset + start],finish - start,&writen,NULL);
		if (berr == FALSE || writen != finish - start)
		{
			printf("Failed to write binary data.Error: %d.\n",GetLastError());
			return FALSE;
		}
	}

	return TRUE;
}

BOOL parse_xblock (unsigned int value, btree64 * bbt, HANDLE fl, DWORD number_to_read, HANDLE hd,
					   unsigned int reference_type, TCHAR * description, xblock * xbl, TCHAR * external_buffer, unsigned __int64 external_offset,
					   unsigned int size, header * h, char is32or64)
{
	unsigned int mask = 0xfffffffc; 
	int i = 0, j = 0;
	BOOL berr;

	//to do: need validation to see that xblock is a correct one and file was not demaged at this point.
	berr = parse_xblock2(external_buffer,xbl,external_offset,number_to_read,is32or64);
	if (!berr)
	{
		free(external_buffer);
		return FALSE;
	}

	//write found data into the output file.
	for ( i = 0; i < xbl->cEnt; i++)
	{
		free(external_buffer);
		if ((external_offset = match_i_id((xbl->bids[i] & mask) ,&size,bbt)) == 0)  
				//if bid has lsb set to 1 set it to 0 and search bbt for a matching node.
		{
			//free(external_buffer);
			return FALSE;
		}

		external_buffer = read_external_data(size,external_offset,number_to_read,hd,h);
		if (external_buffer == NULL)
		{
			printf("Failed to read external data.\n");
			free(xbl->bids);
			free(external_buffer);
			return FALSE;
		}
		
		//needs crc check here
		if (h->encryption == 0x01)
		{
			CryptPermute(&external_buffer[external_offset % number_to_read],size,FALSE);
		}

		if(i == 0)
		{
			berr = write_message_data (external_buffer,0,size,description,reference_type,value,fl,external_offset % number_to_read);
			if(!berr)
			{
				free(xbl->bids);
				free(external_buffer);
				return FALSE;
			}
		}
		else
		{
			berr = write_message_data(external_buffer,0,size,"",reference_type,value,fl,external_offset % number_to_read);
			if(!berr)
			{
				free(xbl->bids);
				free(external_buffer);
				return FALSE;
			}
		}
	}
	
	free(xbl->bids);
	free(external_buffer);

	return TRUE;
}

BOOL parse_xblock2 (TCHAR * buffer, xblock * xbl, unsigned __int64 offset, DWORD number_to_read, char is32or64)
{
	int i,j;
	int step = (is32or64 == 1 ? 4 : 8);

	memcpy(&xbl->cEnt,&buffer[(offset % number_to_read) + 2],2);
	memcpy(&xbl->lcbTotal,&buffer[(offset % number_to_read) + 4],4);
	xbl->bids = (unsigned __int64*) malloc(sizeof(unsigned __int64) * xbl->cEnt);
	if (xbl->bids == NULL)
	{
		return FALSE;
	}

	for(i = 0, j = 8; i < xbl->cEnt; i++, j+=step)
	{
		xbl->bids[i] = 0;
		memcpy(&xbl->bids[i],&buffer[(offset % number_to_read) + j],step); 
	}

	return TRUE;
}

int get_block_type(TCHAR * buffer, unsigned int offset)
{
	int temp = 0;

	memcpy(&temp,&buffer[offset + 2],2);
	if (temp == _bc || temp == _7c)
		return temp;
	else 
	{
		memcpy(&temp,&buffer[offset],2);
		if (temp == _01)
			return _01;
		else
			return _none;
	}
}

