#ifndef _STRUCTURES_H_
#define _STRUCTURES_H_

enum indexes {fl_offset = 1, descriptor };

enum assosiated_descriptors {_none = 0, _bc = 0xbcec, _7c = 0x7cec, 
	_01 = 0x0101, _ok = 0x0001/*used for indicating correct block, but it is neither PC or TC*/ };

typedef struct pst_header{
	unsigned __int64 size;                          //offset  size 8
	unsigned __int64 descriptor_backpointer;        //offset  size 8
	unsigned __int64 descriptor_offset;             //offset  size 8
	unsigned __int64 file_offset_backpointer;       //offset  size 8
	unsigned __int64 file_offset;                   //offset  size 8
	char encryption;                                //offset 0x0201 size 1
}header;

typedef struct _item_leaf{
	unsigned int id2;
	unsigned int i_id;
	unsigned int child_i_id;
}item_leaf;

typedef struct _item_0002
{
	unsigned char signature;
	unsigned char level;
	unsigned short count;
	item_leaf * data;
}item_0002;

typedef struct __07_header{
	unsigned char signature;
	unsigned char item_count;
    unsigned short _4b;
	unsigned short _2b;
	unsigned short _1b;
	unsigned short record_size;
	unsigned int b5_offset;
	unsigned int index_2_offset;
}_07_header;

typedef struct __07_rowindex{
	unsigned int dwRowID;
	unsigned short dwRowIndex;
}_07_rowindex;

typedef struct __07_coldesc{
	unsigned short wPropID;
	unsigned short wPropType;
	unsigned short ibData;
	unsigned char cbData;
	unsigned char iBit;
}_07_coldesc;

typedef struct _xblock{ //btype = 0x01 and cLevel = 0x01
	unsigned short cEnt;       //number of bid's in xblock
	unsigned int lcbTotal;     //total size in bytes of all bid's
	unsigned __int64 * bids;       //array of bid entries in xblock
}xblock;

enum nid_type{
	nid_type_hid = 0x00,
	nid_type_internal,
	nid_type_normal_folder,
	nid_type_search_folder,
	nid_type_normal_message,
	nid_type_attachment,                   //optional for a message
	nid_type_search_update_queue,
	nid_type_seach_criteria_object,
	nid_type_assoc_message,
	nid_type_contents_table_index,
	nid_type_receive_folder_table,
	nid_type_outgoing_queue_table,
	nid_type_hierarchy_table,
	nid_type_contents_table,
	nid_type_assoc_contents_table,
	nid_type_search_contents_table,
	nid_type_attachment_table,              //optional for a message
	nid_type_recipient_table,               //required for a message
	nid_type_search_table_index,
	nid_type_ltp = 0x1f                     //external subnode for a message
};

//returns type of a node, which is determined by first 5 bits on NID.
unsigned char get_node_type (unsigned __int64 desc_i_id);

#endif